#!/usr/bin/env node

const { execSync } = require('child_process');

function runCommand(command) {
	console.log(`🏃 RUNNING: ${command}`);
	try {
		execSync(command, { stdio: 'inherit' });
	} catch (err) {
		console.error(`⛔️ FAILED: ${command}`, err);
		return false;
	}
	return true;
}

const repoName = process.argv[2];
const gitCheckoutCommand = `git clone --depth 1 https://github.com/OllieJT/create-svelte-trpc ${repoName}`;
const installDepsCommand = `cd ${repoName} && npm install`;

console.log(`🧑‍💻 CLONING: ${repoName}...`);

const checkedOut = runCommand(gitCheckoutCommand);
if (!checkedOut) process.exit(-1);

console.log(`📦 Installing dependencies for ${repoName}...`);
const installedDeps = runCommand(installDepsCommand);
if (!installedDeps) process.exit(-1);

console.log(`📦 ...dependencies installed!`);

console.log(`cd ${repoName} && npm start`);
