import type { inferAsyncReturnType } from '@trpc/server';
import * as trpc from '@trpc/server';
import type { ResponseMetaFn } from 'trpc-sveltekit/dist/types';
import trpcTransformer from 'trpc-transformer';

export const createContext = () => {
	// ...
	return {
		/** context data */
	};
};

export const responseMeta: ResponseMetaFn<Router> = ({ type, errors }) => {
	if (type === 'query' && errors.length === 0) {
		const ONE_DAY_IN_SECONDS = 60 * 60 * 24;
		return {
			headers: {
				'cache-control': `s-maxage=1, stale-while-revalidate=${ONE_DAY_IN_SECONDS}`
			}
		};
	}
	return {};
};

export const router = trpc
	.router<inferAsyncReturnType<typeof createContext>>()
	.transformer(trpcTransformer)
	// queries and mutations...
	.query('hello', {
		resolve: () => 'world'
	});

export type Router = typeof router;
